// created on 10/02/2005 at 18:53
using Gtk;
using Gdk;
using System;

public class CheezeColorSelectionDialog : Gtk.ColorSelectionDialog{
	//This is a generic color selection dialog, as from Gtk, but
	//it knows what is attached to, and it keeps track of whether, for
	//that parent we are adjusting foreground or background, and makes
	//cheezepad document format color tags that look like this:
	//<Foregroundrgb:255-255-255> whatever your text is </Foregroundrgb:255-255-255>
	//or if we're in teh background: 
	//<Backgroundrgb:255-255-255>text</Backgroundrgb:255-255-255>
	private CheezePadWindow parent_window;	
	private bool isForeground;

	public CheezeColorSelectionDialog(CheezePadWindow parent,bool fg,string t):base(t){
		parent_window = parent;
		isForeground = fg;
		ColorSelection.HasOpacityControl = false;
		OkButton.Clicked += new EventHandler (choose_color);
		CancelButton.Clicked += new EventHandler (cancel_clicked);
		this.ShowAll();
	}
	
	void choose_color(object o, EventArgs args){
		byte red;
		byte green;
		byte blue;
		//For whatever reason these are shorts, we are forced to scale to 
		//a value betwixt 255 and 0, from one that is between 65536 and 0.
		//There is probably a better way, but this works, and isn't a smelly hack
		red = ((byte)(255.0*(((float)ColorSelection.CurrentColor.Red)/65536.0)));
		green = ((byte)(255.0*(((float)ColorSelection.CurrentColor.Green)/65536.0)));
		blue = ((byte)(255.0*(((float)ColorSelection.CurrentColor.Blue)/65536.0)));
		
		String color_name;
		//Foreground color tag
		if(isForeground){
			color_name = String.Concat("Foregroundrgb:",
										red.ToString(),"-",
										green.ToString(),"-",
										blue.ToString());
			((CheezeBuffer) parent_window.texty.Buffer).
							remove_tag_class("Foreground");
		}
		//background color tag
		else{
			color_name = String.Concat("Backgroundrgb:",
										red.ToString(),"-",
										green.ToString(),"-",
										blue.ToString());
			((CheezeBuffer) parent_window.texty.Buffer).
							remove_tag_class("Background");
		}
		
		//This tag already exists
		if(((CheezeBuffer) parent_window.texty.Buffer).tag_exists(color_name)){
			((CheezeBuffer) parent_window.texty.Buffer).
							toggle_tag_active(color_name);
		}
		//This tag does not already exist
		else{
			((CheezeBuffer) parent_window.texty.Buffer).
							create_new_color_tag(isForeground,
				            					 color_name,
				            					 ColorSelection.CurrentColor);
			((CheezeBuffer) parent_window.texty.Buffer).
							toggle_tag_active(color_name);
		}
		//get rid of this dialog
		this.Destroy();
	}
	void cancel_clicked(object o, EventArgs args){
		this.Destroy();
	}
}