// created on 10/05/2005 at 11:43
using System;
using Gtk;


class CheezePadMenu : Gtk.MenuBar{
	
	Gtk.AccelGroup accel_group;
	CheezePadWindow parent_window;
	public CheezePadMenu(Gtk.AccelGroup accel,CheezePadWindow parent){
		accel_group = accel;	
		parent_window = parent;	
		Gtk.MenuItem file_item = new MenuItem(Mono.Unix.Catalog.GetString("_File"));			
		file_item.Submenu = Cheeze_File_Menu(accel_group);
		file_item.AddAccelerator("activate",
                                accel_group,
                                (uint) Gdk.Key.f,
                                Gdk.ModifierType.Mod1Mask,
                                Gtk.AccelFlags.Visible);

		Gtk.MenuItem edit_item = new MenuItem(Mono.Unix.Catalog.GetString("_Edit"));
		edit_item.Submenu = Cheeze_Edit_Menu(accel_group);
		edit_item.AddAccelerator("activate",
								 accel_group,
								 (uint) Gdk.Key.e,
								 Gdk.ModifierType.Mod1Mask,
								 Gtk.AccelFlags.Visible);
		Gtk.MenuItem text_item = new MenuItem(Mono.Unix.Catalog.GetString("_Text"));
		text_item.Submenu = Cheeze_Text_Menu(accel_group);
		text_item.AddAccelerator("activate",
								 accel_group,
								 (uint) Gdk.Key.t,
								 Gdk.ModifierType.Mod1Mask,
								 Gtk.AccelFlags.Visible);
								 
		Append(file_item);
		Append(edit_item);
		Append(text_item);
	}	
	
		
Gtk.Menu Cheeze_Edit_Menu(Gtk.AccelGroup accel_group){
		Menu edit_menu = new Menu();
		//the stuff in the menu
		Gtk.ImageMenuItem cut_item = new Gtk.ImageMenuItem(Mono.Unix.Catalog.GetString("Cut		"));
		cut_item.Image = new Gtk.Image(Gtk.Stock.Cut,Gtk.IconSize.Menu);
		cut_item.AddAccelerator("activate",
                                accel_group,
                                (uint) Gdk.Key.x,
                                Gdk.ModifierType.ControlMask,
                                Gtk.AccelFlags.Visible);

		Gtk.ImageMenuItem copy_item = new Gtk.ImageMenuItem(Mono.Unix.Catalog.GetString("_Copy		"));
		copy_item.Image = new Gtk.Image(Gtk.Stock.Copy,Gtk.IconSize.Menu);
		copy_item.AddAccelerator("activate",
                                accel_group,
                                (uint) Gdk.Key.c,
                                Gdk.ModifierType.ControlMask,
                                Gtk.AccelFlags.Visible);

		
		Gtk.ImageMenuItem paste_item = new Gtk.ImageMenuItem(Mono.Unix.Catalog.GetString("_Paste		"));
		paste_item.Image = new Gtk.Image(Gtk.Stock.Paste,Gtk.IconSize.Menu);
		paste_item.AddAccelerator("activate",
                                accel_group,
                                (uint) Gdk.Key.v,
                                Gdk.ModifierType.ControlMask,
                                Gtk.AccelFlags.Visible);
		
		Gtk.ImageMenuItem delete_item = new Gtk.ImageMenuItem(Mono.Unix.Catalog.GetString("Delete		"));
		delete_item.Image = new Gtk.Image(Gtk.Stock.Delete,Gtk.IconSize.Menu);
		delete_item.AddAccelerator("activate",
                                accel_group,
                                (uint) Gdk.Key.d,
                                Gdk.ModifierType.ControlMask,
                                Gtk.AccelFlags.Visible);
		
		
		
		//stuff that happens
		cut_item.Activated += new EventHandler (cut_menu_item);
		copy_item.Activated += new EventHandler (copy_menu_item);
		paste_item.Activated += new EventHandler (paste_menu_item);
		delete_item.Activated += new EventHandler (delete_menu_item);
		//put the edit menubar together
		edit_menu.Append(cut_item);
		
		edit_menu.Append(copy_item);
		edit_menu.Append(paste_item);
		edit_menu.Append(delete_item);
		return edit_menu;
	}


Gtk.Menu Cheeze_File_Menu(Gtk.AccelGroup accel_group){
	////////////////////////////
		//File Menu
		Menu file_menu = new Menu();
		
		//the stuff in the menu
		
		Gtk.ImageMenuItem new_item = new Gtk.ImageMenuItem(Mono.Unix.Catalog.GetString("_New		"));
		new_item.Image = new Gtk.Image(Gtk.Stock.New,Gtk.IconSize.Menu);
		new_item.Activated += new EventHandler (new_menu_item);
		new_item.AddAccelerator("activate",
                                accel_group,
                                (uint) Gdk.Key.n,
                                Gdk.ModifierType.ControlMask,
                                Gtk.AccelFlags.Visible);
        new_item.Show();
		Gtk.ImageMenuItem open_item = new Gtk.ImageMenuItem(Mono.Unix.Catalog.GetString("_Open...		"));
		open_item.Image = new Gtk.Image(Gtk.Stock.Open,Gtk.IconSize.Menu);
		open_item.AddAccelerator("activate",
                                accel_group,
                                (uint) Gdk.Key.O,
                                Gdk.ModifierType.ControlMask,
                                Gtk.AccelFlags.Visible);
		Gtk.ImageMenuItem save_item = new Gtk.ImageMenuItem(Mono.Unix.Catalog.GetString("_Save...		"));
		save_item.Image = new Gtk.Image(Gtk.Stock.Save,Gtk.IconSize.Menu);
		save_item.AddAccelerator("activate",
                                accel_group,
                                (uint) Gdk.Key.S,
                                Gdk.ModifierType.ControlMask,
                                Gtk.AccelFlags.Visible);
		Gtk.ImageMenuItem exit_item = new Gtk.ImageMenuItem(Mono.Unix.Catalog.GetString("_Quit		"));
		exit_item.Image = new Gtk.Image(Gtk.Stock.Quit,Gtk.IconSize.Menu);
		exit_item.AddAccelerator("activate",
                                accel_group,
                                (uint) Gdk.Key.Q,
                                Gdk.ModifierType.ControlMask,
                                Gtk.AccelFlags.Visible);
		//stuff that happens
		Gtk.MenuItem spacer = new Gtk.SeparatorMenuItem ();
		spacer.Show ();
		
		save_item.Activated += new EventHandler (save_menu_item);
		open_item.Activated += new EventHandler (open_menu_item);
		exit_item.Activated += new EventHandler (exit_menu_exit);
		//put the file menubar together
		file_menu.Append(new_item);
		file_menu.Append(open_item);
		file_menu.Append(save_item);
		file_menu.Append(spacer);
		file_menu.Append(exit_item);
		return file_menu;
	}
	
Gtk.Menu Cheeze_Text_Menu(Gtk.AccelGroup accel_group){
	////////////////////////////
		//File Menu
		Menu text_menu = new Menu();
		
		//the stuff in the menu
		
		Gtk.ImageMenuItem bold_item = new Gtk.ImageMenuItem(Mono.Unix.Catalog.GetString("_Bold		"));
		bold_item.Image = new Gtk.Image(Gtk.Stock.Bold,Gtk.IconSize.Menu);
		bold_item.AddAccelerator("activate",
                                accel_group,
                                (uint) Gdk.Key.b,
                                Gdk.ModifierType.ControlMask,
                                Gtk.AccelFlags.Visible);
        bold_item.Show();
		Gtk.ImageMenuItem italic_item = new Gtk.ImageMenuItem(Mono.Unix.Catalog.GetString("_Italic		"));
		italic_item.Image = new Gtk.Image(Gtk.Stock.Italic,Gtk.IconSize.Menu);
		italic_item.AddAccelerator("activate",
                                accel_group,
                                (uint) Gdk.Key.i,
                                Gdk.ModifierType.ControlMask,
                                Gtk.AccelFlags.Visible);
        
		Gtk.ImageMenuItem underline_item = new Gtk.ImageMenuItem(Mono.Unix.Catalog.GetString("_Underline		"));
		underline_item.Image = new Gtk.Image(Gtk.Stock.Underline,Gtk.IconSize.Menu);
		underline_item.AddAccelerator("activate",
                                accel_group,
                                (uint) Gdk.Key.u,
                                Gdk.ModifierType.ControlMask,
                                Gtk.AccelFlags.Visible);
        
		Gtk.ImageMenuItem fg_item = new Gtk.ImageMenuItem(Mono.Unix.Catalog.GetString("_Foreground Color	"));
		fg_item.Image = new Gtk.Image(Gtk.Stock.SelectColor,Gtk.IconSize.Menu);
		fg_item.AddAccelerator("activate",
                                accel_group,
                                (uint) Gdk.Key.f,
                                Gdk.ModifierType.ControlMask,
                                Gtk.AccelFlags.Visible);
		Gtk.ImageMenuItem bg_item = new Gtk.ImageMenuItem(Mono.Unix.Catalog.GetString("Bac_kground Color	"));
		bg_item.Image = new Gtk.Image(Gtk.Stock.SelectColor,Gtk.IconSize.Menu);
		bg_item.AddAccelerator("activate",
                                accel_group,
                                (uint) Gdk.Key.k,
                                Gdk.ModifierType.ControlMask,
                                Gtk.AccelFlags.Visible);
		Gtk.ImageMenuItem left_item = new Gtk.ImageMenuItem(Mono.Unix.Catalog.GetString("_Left Justify	"));
		left_item.Image = new Gtk.Image(Gtk.Stock.JustifyLeft,Gtk.IconSize.Menu);
		left_item.AddAccelerator("activate",
                                accel_group,
                                (uint) Gdk.Key.l,
                                Gdk.ModifierType.ControlMask,
                                Gtk.AccelFlags.Visible);
		Gtk.ImageMenuItem center_item = new Gtk.ImageMenuItem(Mono.Unix.Catalog.GetString("C_enter Justify	"));
		center_item.Image = new Gtk.Image(Gtk.Stock.JustifyCenter,Gtk.IconSize.Menu);
		center_item.AddAccelerator("activate",
                                accel_group,
                                (uint) Gdk.Key.e,
                                Gdk.ModifierType.ControlMask,
                                Gtk.AccelFlags.Visible);
		Gtk.ImageMenuItem right_item = new Gtk.ImageMenuItem(Mono.Unix.Catalog.GetString("_Right Justify	"));
		right_item.Image = new Gtk.Image(Gtk.Stock.JustifyRight,Gtk.IconSize.Menu);
		right_item.AddAccelerator("activate",
                                accel_group,
                                (uint) Gdk.Key.r,
                                Gdk.ModifierType.ControlMask,
                                Gtk.AccelFlags.Visible);

		//stuff that happens
		Gtk.MenuItem spacer = new Gtk.SeparatorMenuItem ();
		spacer.Show ();
		Gtk.MenuItem spacer2 = new Gtk.SeparatorMenuItem ();
		spacer2.Show ();
		
		bold_item.Activated += new EventHandler (bold_btn_clicked);
		italic_item.Activated += new EventHandler (italic_btn_clicked);
		underline_item.Activated += new EventHandler (underline_btn_clicked);
		fg_item.Activated += new EventHandler (fg_color_btn_clicked);
		bg_item.Activated += new EventHandler (bg_color_btn_clicked);
		left_item.Activated += new EventHandler (left_btn_clicked);
		right_item.Activated += new EventHandler (right_btn_clicked);
		center_item.Activated += new EventHandler (center_btn_clicked);
		
		//put the file menubar together
		text_menu.Append(bold_item);
		text_menu.Append(italic_item);
		text_menu.Append(underline_item);
		text_menu.Append(spacer);
		text_menu.Append(fg_item);
		text_menu.Append(bg_item);
		text_menu.Append(spacer2);
		text_menu.Append(left_item);
		text_menu.Append(center_item);
		text_menu.Append(right_item);		
		return text_menu;
	}
	
	void cut_menu_item(object o, EventArgs args){
		parent_window.texty.Buffer.CutClipboard(Clipboard.Get(Gdk.Selection.Clipboard),true);
	}
	
	void copy_menu_item(object o, EventArgs args){
		parent_window.texty.Buffer.CopyClipboard(Clipboard.Get (Gdk.Selection.Clipboard));
	}
								
	void paste_menu_item(object o, EventArgs args){
		((CheezeBuffer) parent_window.texty.Buffer).active_tags.Clear();
		parent_window.texty.Buffer.PasteClipboard(Clipboard.Get (Gdk.Selection.Clipboard));
	}

	void delete_menu_item(object o, EventArgs args){
		((CheezeBuffer) parent_window.texty.Buffer).delete_selection();
	}
	
	void exit_menu_exit(object o, EventArgs args)
	{
		Application.Quit ();
	}
	
	void open_menu_item(object o, EventArgs args)
	{
		CheezeFileOpenDialog open_new_file = new CheezeFileOpenDialog(parent_window,"Open File...");
		//open_new_file.Run();
	}
	
	void save_menu_item(object o, EventArgs args)
	{
		CheezeFileSaveDialog save_file = new CheezeFileSaveDialog(parent_window,"Save File...");
		//save_file.Run();
	}
	
	void new_menu_item(object o, EventArgs args)
	{
		new CheezePadWindow("(Unsave Document)",null);
	}
	
	void fg_color_btn_clicked(object o, EventArgs args){
		CheezeColorSelectionDialog colorpicker = new CheezeColorSelectionDialog(parent_window,true,"Select New Foreground Color");
	}

	void bg_color_btn_clicked(object o, EventArgs args){
		CheezeColorSelectionDialog colorpicker = new CheezeColorSelectionDialog(parent_window,false,"Select New Background Color");
	}
	
	void bold_btn_clicked(object o, EventArgs args){
		((CheezeBuffer) parent_window.texty.Buffer).toggle_tag_active("Style:bold");
	}
	
	void italic_btn_clicked(object o, EventArgs args){
		((CheezeBuffer) parent_window.texty.Buffer).toggle_tag_active("Style:italic");
	}
	
	void underline_btn_clicked(object o, EventArgs args){
		((CheezeBuffer) parent_window.texty.Buffer).toggle_tag_active("Style:underline");
	}
	

	/*The Following 3 functions are text properties that are mutually exlusive
	 * to one another when applied:
	 * ie: left/center/right justify
	 * ie: text can only have 1 fg color.
	 * a lot of the work being done here is being done to turn off the old one
	 * and to turn on the new one...
	 * there must be a better way -- but what?!
	 */
	//Left Justify Handler
	void left_btn_clicked(object o, EventArgs args){
		((CheezeBuffer) parent_window.texty.Buffer).remove_tag_class_from_line("Justify");	
		((CheezeBuffer) parent_window.texty.Buffer).apply_tag_to_line("Justify:left");
	}
	
	//Center Justify Handler
	void center_btn_clicked(object o, EventArgs args){
		((CheezeBuffer) parent_window.texty.Buffer).remove_tag_class_from_line("Justify");	
		((CheezeBuffer) parent_window.texty.Buffer).apply_tag_to_line("Justify:center");
	}
	
	//Right Justify Handler
	void right_btn_clicked(object o, EventArgs args){
		((CheezeBuffer) parent_window.texty.Buffer).remove_tag_class_from_line("Justify");	
		((CheezeBuffer) parent_window.texty.Buffer).apply_tag_to_line("Justify:right");
	}	

	
}